using FarPoint.Win.Spread.CellType;
using System.Data;

namespace CheckboxHeaderFilter
{
    public partial class Form1 : Form
    {

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            fpSpread1.DataSource = GetDataTable();
            fpSpread1.ActiveSheet.Columns[2].Width = 140;
            fpSpread1.ActiveSheet.ColumnHeader.Columns[2].CellType = new CheckBoxHeaderFilter()
            {
                Caption = "Is Present"
            };
            fpSpread1.ActiveSheet.Columns[1].AllowAutoFilter = true;
            fpSpread1.ActiveSheet.Columns[2].AllowAutoFilter = true;
        }

        public DataTable GetDataTable()
        {
            DataTable dataTable = new DataTable("Attendance");

            // Define columns
            dataTable.Columns.Add("Id", typeof(string));
            dataTable.Columns.Add("Name", typeof(string));
            dataTable.Columns.Add("IsPresent", typeof(bool));

            // Add 10 entries
            for (int i = 1; i <= 10; i++)
            {
                DataRow row = dataTable.NewRow();
                row["Id"] = $"ID{i}";
                row["Name"] = $"Person {i}";
                row["IsPresent"] = i % 2 == 0; // Alternating true/false for IsPresent
                dataTable.Rows.Add(row);
            }

            return dataTable;
        }
    }
}